import { Noel, NoelConfig, NoelEvent, NoelEventListenerManager, NoelLogger } from './interfaces';
import { NoelEventListener } from './types';
import { NoelEventImp } from './event';
export declare class NoelImp implements Noel {
    private noEventListenersWarning;
    private eventsMap;
    private logger;
    private replayEnabled;
    private replayBufferSize;
    constructor(config?: NoelConfig);
    emit(eventName: string, ...eventArgs: Array<any>): void;
    on(eventName: string, listener: NoelEventListener): NoelEventListenerManager;
    removeListener(eventName: string, listener: NoelEventListener): void;
    removeEventListener(event: NoelEventImp, listener: NoelEventListener): void;
    setLogger(logger: NoelLogger): void;
    enableNoEventListenersWarning(): void;
    disableNoEventListenersWarning(): void;
    replayIsEnabled(): boolean;
    enableReplay(): void;
    disableReplay(): void;
    setReplayBufferSize(replayBufferSize: number): void;
    clearEventsReplayBuffers(): void;
    clearReplayBufferForEvent(eventName: string): void;
    getEvent(eventName: string): NoelEvent;
    removeEvent(eventName: string): void;
    clearListenersForEvent(eventName: string): void;
    private makeEvent(eventName);
    private setEventsReplayBuffersSize(replayBuffersSize);
    private disableEventsReplay();
    private enableEventsReplay();
    private getEvents();
    private getEventsMap();
}
export * from './errors';
export * from './interfaces';
export * from './types';
export default NoelImp;
